#include <iostream>
#include <vector>
using namespace std;
int main()
{
	int n, k;
	cin >> n >> k;
	vector <uint64_t> nums(n);
	for (int64_t i = 0; i < n; i++)
	{
		cin >> nums[i];
		if (nums[i] != 0) k--;
	}
	cout << ((k > 0) ? 0 : 1);
	return 0;

	vector < vector < uint64_t>> dp(k + 1, vector < uint64_t>(n, 0));   // максимальный и при К-той точке после Н-ного элемента
	dp[0] = nums;
	{
		for (size_t i = 1; i < n; i++)
		{
			dp[0][i] = dp[0][i] | dp[0][i - 1];
		}
	}

	for (int64_t Tk = 0; Tk < k; Tk++)
	{
		for (int64_t Tn = 0; Tn < n; Tn++)
		{
			uint64_t Tec = nums[Tn];
			for (int64_t Tnn = Tn - 1; Tnn >= 0; Tnn--)
			{
				dp[Tk + 1][Tn] = max(dp[Tk + 1][Tn], dp[Tk][Tnn] & Tec);
				Tec = Tec | nums[Tnn];
			}
		}
	}

	//	uint64_t ans = 0;
		//for (size_t i = 0; i < n; i++)
		//{
	//		ans = max(ans, dp[k-1][i]);
		//}

	cout << dp[k - 1][n - 1];
	return 0;
}
